updateMoments <- function(x,D,taudata,numat){
  CV <- function(V,iV,P) V-V%*%t(P)%*%iV%*%P%*%V    
  VA <- diag(rep(D,each=4)*x$H)
  Vv <- taudata/x$ms
  DT <- diag(rep(taudata,x$ms))
  VE <- DT+x$P%*%numat%*%t(x$P)
  h <- diag(rep(1/sqrt(x$ms),x$ms))
  PT <- (diag(rep(1,sum(x$ms)))-h%*%x$P%*%t(x$P)%*%h)
  VT <- PT%*%DT
  Dh <- diag(sqrt(x$data$height))
  VM <- x$Tm%*%VA%*%t(x$Tm)+Dh%*%VE%*%Dh
  iVM <- solve(VM)
  x$CVA <- diag(CV(VA,iVM,x$Tm))
  CVu <- CV(numat,iVM,Dh%*%x$P)
  CVv <- diag(CV(diag(Vv),iVM,Dh%*%x$P))
  CVT <- CV(VT,iVM,Dh)
  Mres <- iVM%*%(x$M-x$Tm%*%x$mu)
  x$std <- (x$M-x$Tm%*%x$mu)/sqrt(diag(VM))
  x$CEA <- x$mu+VA%*%t(x$Tm)%*%Mres
  CEu <- numat%*%t(x$P)%*%Dh%*%Mres
  CEv <- diag(Vv)%*%t(x$P)%*%Dh%*%Mres
  CET <- VT%*%Dh%*%Mres
  x$nu <- CVu+CEu%*%t(CEu)
  x$tau <- t(x$P)%*%(diag(PT%*%CVT)+CET*CET)+x$ms*(CVv+CEv^2)
  x$Hot <- sum(Mres*(x$M-x$Tm%*%x$mu))
  x$dev <- log(det(VM))+x$Hot
  x
}

EstimV <- function(x){
  S <- length(x[[1]]$ms)
  nu <- matrix(0,S,S)
  tau <- rep(0,S)
  df <- rep(0,S)
  for(i in x){
    nu <- nu+i$nu
    tau <- tau+i$tau
    df <- df+i$ms}
  list(nu=nu/length(x),tau=as.vector(tau/df))
}
EstimA <- function(y){
  S <- length(y[[1]]$ms)
  al <- rep(0,S)
  deno <- rep(0,S)
  summat <- summatrix(rep(4,S))
  for(x in y){
    al <- al+summat%*%as.vector(x$CEA)
    deno <- deno+summat%*%as.vector(x$H)
  }
  al <- al/deno
  si <- rep(0,4*S)
  for(i in 1:length(y)){
    y[[i]]$mu <- rep(al,each=4)*y[[i]]$H
    si <- si+(y[[i]]$CVA+(y[[i]]$CEA-y[[i]]$mu)^2)/y[[i]]$H
  }
  list(al=as.vector(al),si=as.vector(summat%*%si/(4*length(y)-1)),y=y)
}

summatrix <- function(ms){
  S <- length(ms)
  summat <- matrix(0,S,sum(ms))
  for(j in 1:S){
    temp <- numeric(0)
    for(k in 1:S){
      temp <- c(temp,as.numeric(rep(k==j,ms[k])))
    }
    summat[j,] <- temp
  }
  summat
}

extract <- function(x,a,uL=T){
  mf <- match.call(expand.dots = FALSE)
  no <- match(c("a"), names(mf), 0)
  if (uL)
    unlist(lapply(x,function(x) eval(mf[[no]]))) else {
      lapply(x,function(x) eval(mf[[no]]))
    }
}
